/***************************************************************
 * bci-messenger.js --------------------------------------------
 *  
 * 
 * 
 ****************************************************************/
 //include ("chrome://bci/content/bci-static.js");



//global msgAccountManager
var gMsgAccountService  = Components.classes["@mozilla.org/messenger/account-manager;1"].getService();
gMsgAccountService.QueryInterface(Components.interfaces.nsIMsgAccountManager);
var gDefAccount; //nsIMsgAccount
//default server
var gServer; //nsIMsgIncomingServer

//variables for getting mail 
var gRootFolder; 
var outNumFolders; 
var gInbox; 
var gMsgURIArray; // array of message URIs
var displayEditor = null;
var BCIMailManager;


dd = function (str) {dump ("---bcimesssenger: " + str + "\n");}

//================================= open mail UI =============
function startBCIMail() {
  dd("startBCIMail()");
  
  //window.openDialog("chrome://bci/content/bci-messenger.xul", "bciMessenger","chrome=no,dependent", {manager: manager, gPref: gPref});
  //window.open("chrome://bci/content/bci-messenger.xul", "_top");
  //window.open("chrome://bci/content/bci-messenger.xul", "bciMessenger");
  //window.opener.openURL("chrome://bci/content/bci-messenger.xul"); //error: window.opener has no properties
  loadURI("chrome://bci/content/bci-messenger.xul");
  
  document.getElementById("bci-menuitem-close-mail").setAttribute("disabled", "false");
  document.getElementById("bci-menuitem-mail").setAttribute("disabled", "true");
  
}

function closeBCIMail() {
  dd("closeBCIMail");
  loadURI("file:///C:/moz/local_html/index.html");
  document.getElementById("bci-menuitem-close-mail").setAttribute("disabled", "true");
  document.getElementById("bci-menuitem-mail").setAttribute("disabled", "false");
}

//moved to bci-messenger.xul
function startup() {
   
  dd("startup()");
   
  gDefAccount = gMsgAccountService.defaultAccount; //nsIMsgAccount
   
  gServer = gDefAccount.incomingServer; //nsIMsgIncomingServer
  gRootFolder = gServer.rootMsgFolder;
  outNumFolders = new Object();
  gInbox = gRootFolder.getFoldersWithFlag(0x1000, 1, outNumFolders);
 
  //does an account exist?
  if(gInbox) {
    gInbox.QueryInterface(Components.interfaces.nsIMsgFolder);
   
    //getting mail from POP3Service --> no symbol "new message"
    var gPOP3Service = Components.classes["@mozilla.org/messenger/popservice;1"].getService();
    gPOP3Service.QueryInterface(Components.interfaces.nsIPop3Service);

    var uri = gPOP3Service.GetNewMail(null, null, gInbox, gServer);
    //initialize editor
    displayEditor = document.getElementById("bci-displayMsg");
    displayEditor.setAttribute("src", "about:blank"); 
    displayEditor.setAttribute("editortype", "text");
     
    //need timeout: mail delivery is very slow!
    window.setTimeout("displayMessages()", 2000);
  }
  else {
    alert("Email account doesn't exist.");
  } 
}
 
function nextMessage() {
  dd("nextMessage() ");
 
   var mailList =document.getElementById("message-list");
   var index = mailList.selectedIndex;
   var items = mailList.getElementsByTagName("listitem");
   var newIndex = index+1;
   if(newIndex == items.length) {
     newIndex = 0; //reached first item again
   }
   mailList.selectItem(items[newIndex]); //new selected item
   
   manager.createMenu("content",1);
     
}
 
 
function displayMessages() {
   
   dd("displayMessages ");
   
   
   // array for msgKeys
   gMsgURIArray = new Array();
   
   var messages = gInbox.getMessages(null);
   
   var mailList = document.getElementById("message-list");
    
   //clear mail list...and array because we can't get only new messages
   var items = mailList.getElementsByTagName("listitem");
   while(items.length > 0) {
     mailList.removeChild(items[0]);
     gMsgURIArray.pop();
   }
   
   while(messages.hasMoreElements()) {
     //dd(" hasMoreElements " + messages.hasMoreElements());
     var mail = messages.getNext(); //nsIMsgDBHdr
     mail.QueryInterface(Components.interfaces.nsIMsgDBHdr);
        
     var subject = mail.mime2DecodedSubject; //to display subject correctly 
     var from = mail.mime2DecodedAuthor;
     
     var time = mail.date; //PRTime, time in microseconds
     //convert time in microseconds into actual time
     var mailDate = new Date(time/1000);
         
     // add msgUri to array
     var msgURI = gInbox.getUriForMsg(mail);
     var lastElement = gMsgURIArray.push(msgURI);
             
     var cell1 = document.createElement("listcell");
     var cell2 = document.createElement("listcell");
     var cell3 = document.createElement("listcell");
        
     cell1.setAttribute("label" , subject);
     cell2.setAttribute("label" , from);
     cell3.setAttribute("label" , mailDate.toLocaleString());
     
     var item = document.createElement("listitem");
   
     item.appendChild(cell1);
     item.appendChild(cell2);
     item.appendChild(cell3);
     
     mailList.appendChild(item);
   
   }
   
   mailList.selectItem(items[0]);
   
   
 }
 
function displayContent() {
 dd("displayContent()");

  var messenger = Components.classes["@mozilla.org/messenger;1"].createInstance();
  
  messenger = messenger.QueryInterface(Components.interfaces.nsIMessenger);
  
  var content;
  //get mailList and index of selected message
  var mailList = document.getElementById("message-list"); 
  var msgIndex = mailList.selectedIndex;
  //get message URI for selected message 
  var uri = gMsgURIArray[msgIndex];
  
  //===================== display message docShell ================================
  var MsgService = messenger.messageServiceFromURI(uri);//nsIMsgMessageService
  //editor
  var myEditor =document.getElementById("bci-displayMsg");
  myEditor.documentCharacterSet ="UTF-8";
  //dd("myEditor.documentCharacterSet " + myEditor.documentCharacterSet);
  //dd("myEditor.contentsMIMEType " + myEditor.contentsMIMEType);
  myEditor.contentsMIMEType = "text/html";
  //dd("myEditor.contentsMIMEType " + myEditor.contentsMIMEType);
  var myEditorDocShell = myEditor.docShell; //nsIDocShell
  myEditorDocShell.QueryInterface(Components.interfaces.nsIDocCharset); //nsIEditorDocShell
  myEditorDocShell.charset = "UTF-8";
  var url = new Object();
  MsgService.DisplayMessage( uri, myEditorDocShell, null, null,"UTF-8", url);
  // tested utf-8,16 and iso8859-1
  
  
}

function reply() {
    dd("reply()");
    
   //get addressField and composeField and clear them
   var addressField = document.getElementById("addressField");
   addressField.value = "";
   var composeArea = document.getElementById("composeArea");
   composeArea.value = "";
    
   //get index of displayed message
   var mailList =document.getElementById("message-list");
   var index = mailList.selectedIndex;
   //get message and author
   var messages = gInbox.getMessages(null);
   var mail;     
   for(var i = 0; i<=index; i++) {  
     mail = messages.getNext();
     mail.QueryInterface(Components.interfaces.nsIMsgDBHdr);
   }
   var address = mail.author;
   // set addressField on reply address
   addressField.value = address;
   
   openSendKeyboard();
 }
 
 
 
 function sendMessage() {
   dd("sendMessage()");
   
   // parameter for sending message
   var msgCompFields = Components.classes["@mozilla.org/messengercompose/composefields;1"].createInstance();
   msgCompFields = msgCompFields.QueryInterface(Components.interfaces.nsIMsgCompFields);
   
   //set msgCompFields (sender, receiver, message body)
   //extract address field
   var addressField = document.getElementById("addressField");
   
   //address in address field
   msgCompFields.from = "bciuser@gmx.de";   
   msgCompFields.to = addressField.value;
   //dd("msgCompFields.to " + msgCompFields.to);
   
   //Subject
   msgCompFields.subject = gPref.mailSubject; //"Nachricht von bciuser";
   //dd("msgCompFields.subject "+ msgCompFields.subject);
      
   //extract message body from composeArea
   var textField = document.getElementById("composeArea");
   //dd("textField in sendMessage() " + textField);
   msgCompFields.body = textField.value;
   
   //nsIMsgIdentity --> get from gDefAccount
   var msgIdentity = gDefAccount.defaultIdentity;//nsIMsgIdentity
   //nsIMsgComposeParams --> parameter for sendMessage()
   var params = Components.classes["@mozilla.org/messengercompose/composeparams;1"].createInstance(); 
   params = params.QueryInterface(Components.interfaces.nsIMsgComposeParams);
   params.smtpPassword = gPref.smtpPassword;//"IwidG4iG";
   params.composeFields = msgCompFields;
   //dd("params.smtpPassword " + params.smtpPassword);
   
   //MsgCompose --> sending message
   var sender = Components.classes["@mozilla.org/messengercompose/compose;1"].createInstance();
   sender = sender.QueryInterface(Components.interfaces.nsIMsgCompose);
   sender.Initialize(null, params);
   sender.SendMsg(1, msgIdentity, null, null, null);// 1 means send later, 0 means send now
													// 0 doesn't work: email is send with empty body
													// so message need to be sent later
   // sendLater													
   var sendLater = Components.classes["@mozilla.org/messengercompose/sendlater;1"].createInstance();
   sendLater = sendLater.QueryInterface(Components.interfaces.nsIMsgSendLater);
   sendLater.SendUnsentMessages(msgIdentity);
}
 
 
function compose() {
  dd("compose()");
  //open keyboard in address field
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
  var browserWindow = wm.getMostRecentWindow("navigator:browser");
  manager = browserWindow.manager;
  gPref = browserWindow.gPref;
  if(manager) {
    //get addressField and composeField and clear them
    var addressField = document.getElementById("addressField");
    addressField.value = "";
    var composeArea = document.getElementById("composeArea");
    composeArea.value = "";
    //get accessible for address field 
    var accAddressField = browserWindow.accService.getAccessibleFor(addressField);//nsIAccessible    
    manager.msgWin = window.openDialog(gPref.keyboardContentAddress, "", "chrome,dependent,dialog=no,alwaysRaised=yes", accAddressField);
    setTimeout("onOpenKeyboard(manager.msgWin)",400);
    dd("manager opened address keyboard successfully");
   }
}


function openSendKeyboard() {
  
  dd("openSendKeyboard()");
  
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var browserWindow = wm.getMostRecentWindow("navigator:browser");
  
  manager = browserWindow.manager;
  gPref = browserWindow.gPref;
  if(manager) {
    dd("manager exists in openSendKeyboard()");
    //get textarea accessible for entering message text
    var composeArea = document.getElementById("composeArea");
    var accComposeArea = browserWindow.accService.getAccessibleFor(composeArea);//nsIAccessible
    dd("accComposeArea " + accComposeArea);   
    manager.msgWin = window.openDialog(gPref.keyboardContentSend, "", "chrome,dependent,dialog=no,alwaysRaised=yes", accComposeArea);
    setTimeout("onOpenKeyboard(manager.msgWin)",400);
  }
  dd("end openSendKeyboard()");
} 


function nextKeyboard() {
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
  var browserWindow = wm.getMostRecentWindow("navigator:browser");
  manager = browserWindow.manager;
  gPref = browserWindow.gPref;
  if(manager.activeMenu) {
    dd("openNextKeyboard()");
    //get textarea accessible for entering message text
    var composeArea = document.getElementById("composeArea");
    var accComposeArea = browserWindow.accService.getAccessibleFor(composeArea);//nsIAccessible  
    manager.msgWin = window.openDialog(gPref.keyboardContentSend, "", "chrome,dependent,dialog=no,alwaysRaised=yes", accComposeArea);
    setTimeout("onOpenKeyboard(manager.msgWin)",1000);
    dd("manager opened next keyboard successfully");
  
  }
}