/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-*/
/**
 * This file is for simulation routines.
 *
 */

function sim(aType) {
  manager.activeMenu.simInit();
  manager.activeMenu.simShortestPaths();
  var now = new Date();

  var p,q;
  for (p=30; p <= 100; p+=5) { // 70..100
    for (q=70; q <= 100; q+=5) {
      try { 
        if (aType == "speller") { // virtual keyboard with 32 letters
          manager.activeMenu.simGo("ABCDEFGHIJKLMNOPQRSTUVWXYZ,.-", 
                                   p,q, // p and q (hit percentages)
            // use probs, runcount, correct wrong letters, verbosity
                                   true, 1000, true, 1); 

        } else if (aType == "menu") { // navigation bar with 7 icons
          manager.activeMenu.simGo("ABCDEFG", p,q, true, 100, false, 1); 

        } else if (aType == "website") { // website with 32 links
        manager.activeMenu.simGo("ABCDEFGHIJKLMNOPQRSTUVWXYZ,.-", 
                                 p,q, false, 1000, false, 1); 
        }
      } catch (ex) {
        dd("There was a problem with the simulation.");
        dd(ex);
      }
    }
  }

  var now1 = new Date();
  dd("Simulation time " + formatDateOffset((now1-now)/1000, "%h:%m"));
  manager.activeMenu.simEnd();
  // output the simulated structure to a .dot file
  var verb;
  var fname = "sim";
  fname += "_"+aType+"_"+manager.activeMenu.treeType;
  if (manager.activeMenu.treeType >= 10)
    fname += "_m"+manager.activeMenu.verifyFrequency;
  if (manager.activeMenu.classCount > 2) 
    fname += "_cl"+manager.activeMenu.classCount;
  //fname += ".dot";
  
  for (verb=0; verb < 3; verb++) 
    manager.activeMenu.toDotFile(fname+"_v"+verb+".dot", verb);
}

function simMatrix() {
  manager.activeMenu.simInit();
  manager.activeMenu.simShortestPaths();
  manager.activeMenu.simShowMatrix();
  manager.activeMenu.simEnd();
}
